﻿Type=StaticCode
Version=6.31
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

'-----------------------------------------------------------------------------------------------------------------------------------------------------
'  RB 				is the radiobutton you want to change
'  Indent 			is how far you want the text to be indented
'  ButtonStates		Array of ButtonState Bitmaps / Filenames  EnableUnSelected / EnableSelected / Disable
'					NOTE:  Only the first two states are required
'-----------------------------------------------------------------------------------------------------------------------------------------------------
Public  Sub LoadRadioButtonStateLists(RB As RadioButton, Indent As Int, ButtonStates() As Object)
  			Dim jo 								As JavaObject

    		Dim sdw 							As StateListDrawable
			Dim state_bitmaps(3)				As BitmapDrawable

  			jo.InitializeStatic("android.graphics.Bitmap")
			
			
			If  ButtonStates.Length > state_bitmaps.Length Then 
				Log("Oops can't have this many passed states either Unselected, Selected, Disable or Unselected, Selected")
				Return
			End If
			
			If  ButtonStates.Length < 2 Then
				Log("Oops Not enough passed states either Unselected, Selected, Disable or Unselected, Selected")
				Return				
			End If
			
			
			Dim PassedDrawable			As BitmapDrawable
			Dim UseBitmap 				As Bitmap
			Dim StateObj				As Object
			
			Dim StateBitmaps			As List
			
			StateBitmaps.Initialize

  			jo.InitializeStatic("android.graphics.Bitmap")
			
			For i = 0 To ButtonStates.Length-1
				StateObj = ButtonStates(i)
				
				If  StateObj Is String Then
					UseBitmap = LoadBitmap(File.DirAssets, StateObj)
				else if StateObj Is Bitmap Then
					UseBitmap = StateObj
				else if StateObj Is BitmapDrawable Then
					PassedDrawable = StateObj
					UseBitmap.Initialize3(PassedDrawable.Bitmap)
				Else
					Log("Oops what are you passing")
					Return
				End If
				
				Dim DrawableBitmap  As BitmapDrawable
				Dim BitmapFrame	 	As Bitmap
				Dim ScaledBitmap 	As Bitmap
				Dim SizeRect		As Rect
				Dim Cnv			 	As Canvas
				'-------------------------------------------------------------------------------------------------------------------------
				'  Make Bitmap Passed the size of the Radio Button field Height (using Height for Height and Width to make a square
				'-------------------------------------------------------------------------------------------------------------------------
				ScaledBitmap.Initialize3(jo.RunMethod("createScaledBitmap", Array(UseBitmap, RB.Height, RB.Height, True)))
				
				BitmapFrame.InitializeMutable(RB.Height+Indent, RB.Height)
				
				SizeRect.Initialize(0, 0, RB.Height, RB.Height)
				
				Cnv.Initialize2(BitmapFrame)
				Cnv.DrawBitmap(ScaledBitmap, SizeRect, SizeRect)
				
				DrawableBitmap.Initialize(BitmapFrame)
				
				state_bitmaps(i) = DrawableBitmap
			Next
			
			'--------------------------------------------------------------------------------------
			'  if we only were passed unselected and selected then use unselected for disable
			'--------------------------------------------------------------------------------------			
			If  ButtonStates.Length = 2 Then
				state_bitmaps(2) = state_bitmaps(0)
			End If
			

    		sdw.Initialize
    		sdw.AddState(sdw.State_Disabled,  								   	state_bitmaps(2))
    		sdw.AddState(sdw.State_Checked,   								   	state_bitmaps(1))
    		sdw.AddState(sdw.State_Unchecked, 									state_bitmaps(0))			
    		sdw.AddState(sdw.State_Enabled,   									state_bitmaps(0))
    		sdw.AddCatchAllState(state_bitmaps(1))			
						
			jo = RB
			
    		jo.RunMethod("setButtonDrawable",Array As Object(sdw))			
			
    		Return
End Sub
